<?php
/*
Plugin Name: Easy Facebook Share Thumbnail
Plugin URI: http://hebeisenconsulting.com/wordpress-easy-facebook-share-thumbnail/
Description: The post's featured image is used as the thumbnail when the page is being shared on facebook. A default image can also be specified.
Version: 1.9
Author: Hebeisen Consulting - R Bueno
Author URI: http://www.hebeisenconsulting.com
License: A "Slug" license name e.g. GPL2

   Copyright 2011 Hebeisen Consulting

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of 
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


Wordpress admin settings and core installations
*/

add_action('admin_menu', 'fbthumbnails_menu');
add_action('wp_head', 'fbthumbnails_head');
add_option('fbthumbnails_head_section', '');
add_option('fbthumbnails_link_rel', '');
define('easy_facebook_share_thumbnails_path', ABSPATH . 'wp-content/plugins/easy-facebook-share-thumbnails');
define('easy_facebook_share_thumbnails_url', get_bloginfo('siteurl') . '/wp-content/plugins/easy-facebook-share-thumbnails/thumbnails/');
define('easy_facebook_share_plugin_url', get_bloginfo('siteurl') . '/wp-content/plugins/easy-facebook-share-thumbnails/');
require easy_facebook_share_thumbnails_path . '/esft-functions.php';

//Check if featured immage is supported on current theme
//If not, set it on      
if(!function_exists('the_post_thumbnail()')){
	add_theme_support( 'post-thumbnails' ); 
	//add_image_size( 'esft_standard_size', 200, 200, true );
	set_post_thumbnail_size( 200, 200, true );
}

if ( function_exists( 'add_image_size' ) ) { 
	add_image_size( 'esft_standard_size', 200, 200, true );
}

function esft_message_admin( $message, $errormsg = false )
{
	if ($errormsg)
		echo '<div id="message" class="error">';
	
	else
		echo '<div id="message" class="updated fade">';
	
	echo "<p><strong>$message</strong></p></div>";
}   

//plugin installation
//create ew table upon activating plugin
function fbthumbnails_install()
{
    global $wpdb;
    $table = $wpdb->prefix . "fbthumbnails";
	if($wpdb->get_var("show tables like '$table'") != $table) {
	    $sql = "CREATE TABLE " . $table . " (
					  id int(11) NOT NULL AUTO_INCREMENT,
					  thumbnail varchar(150) NOT NULL,
					  path text NOT NULL,
					  url text NOT NULL,
					  active INT(1) NOT NULL,
					  image_type varchar(10) NOT NULL,
					  PRIMARY KEY (id)
					)";
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	    dbDelta($sql);
	}
}

function fbthumbnails_uninstall(){
	global $wpdb;
        $table = $wpdb->prefix . "fbthumbnails";
        
        $wpdb->query("DROP TABLE IF EXISTS $table");
}

register_activation_hook(__FILE__,'fbthumbnails_install');
register_deactivation_hook(__FILE__,'fbthumbnails_uninstall');

//plugin <head></head> overriding
function fbthumbnails_head()
{
	global $wpdb;	
	global $post;
	$table = $wpdb->prefix . "fbthumbnails";
	$post_id = $post;	
	   		//echo $post_id;    
		    if ( is_single($post_id) || is_page($post_id) )
		    {
		    	//print_r( $post );
		    	$post_date = $post_id->post_date;
		    	$post_modified = $post_id->post_modified;
		    	
		    	$post_id = $post_id->ID;
		      	$site_title = get_the_title($post->ID);
		      	$fb_thumbnail_src = wp_get_attachment_image_src(get_post_thumbnail_id($thumbnail->ID), array( 200, 200 ) );
		      	//wp_get_attachment_image_src( get_the_post_thumbnail( $post_id, 'medium' ) );
		      	//wp_get_attachment_image_src(get_post_thumbnail_id($thumbnail->ID, 'medium'));
		      	$post_var = get_post($post_id, ARRAY_A);		      	
		        $raw_content = $post_var['post_content'];	
		        if( $post_var['post_content'] != "" ):
		        	$content = $post_var['post_excerpt'];
		        else:      
				$content = substr( strip_shortcodes( strip_tags($raw_content) ), 0, strpos( $raw_content, "." ) + 1 );			
			endif;
			//$content = strpos( $raw_content, "." );
	
			 echo "\n";
			 echo "\n";
			 //echo $post_id;
			 echo "<!-- Easy Facebook Share Thumbnails -->";
			 //echo "<!-- This is a Post/Page -->";
			 echo "\n";
			 echo '<meta property="og:title" content="'. $site_title . '"/>' . "\n";
			 echo '<meta property="og:type" content="article"/>' . "\n";
			 echo '<meta property="og:url" content="' . get_permalink($post_id->ID) . '"/>' . "\n";		
			 
			 //site name
			 if( get_option( 'esft_site_name' ) != "" ):
			 	echo '<meta property="og:site_name" content="' . get_option( 'esft_site_name' ) . '"/>' . "\n";
			 else:
			 	echo '<meta property="og:site_name" content="' . get_bloginfo('name') . '"/>' . "\n";
			 endif;
			 
			 //app id
			 if( get_option( 'esft_app_id' ) != "" ):
			 	echo '<meta property="fb:app_id" content="' . get_option( 'esft_app_id' ) . '"/>' . "\n";			 
			 endif;
			 
			 //published_time
			 if( get_option( 'esft_published_time' ) != "" ):
			 	echo '<meta property="article:published_time" content="' . $post_date . '"/>' . "\n";			
			 endif;
			 
			 //modified_time
			 if( get_option( 'esft_modified_time' ) != "" ):
			 	echo '<meta property="article:modified_time" content="' . $post_modified . '"/>' . "\n";
			 endif;
			 
			 echo '<meta property="og:description" content="' . $content . '"/>' . "\n";
			 
			 if( has_post_thumbnail($post->ID) ):
			 
			 	//echo "\n";
			 	//echo "<!-- Has Featured Image -->";
			 	//echo "\n";
			 	
			 	/*
			 	 @ Check if this post has metadata for featured image overlay. 
			 	 @ If none, display normal thumbnail
			 	*/			 	
			 	$md=get_post_meta($post->ID, "_esft_meta");
			 				 	
			 	if( $md ):
			 		
			 		//user choose not to overlay
			 		if( $md[0] == "none" ):
			 			echo '<meta property="og:image" content="' . $fb_thumbnail_src[0] . '" />' . "\n" . '<link rel="image_src" href="' . $fb_thumbnail_src[0] . '"/>' . "\n";
			 		else:
				 		/*
				 		 @ User choose grudge, masked and punched
				 		 @ if nothing comes here, it might premium
				 		*/
				 		if( $md[0] == "grunge" || $md[0] == "masked" || $md[0] == "punch" || $md[0] == "rounded" ):
				 			/*
				 			 @ Check if already in cache
				 			 @ if none, create thumbnail 
				 			 @ and use it
				 			*/
				 			$file_ext = ltrim( strstr( basename( $fb_thumbnail_src[0] ), '.' ), '.' );
				 			
				 			if( file_exists( easy_facebook_share_thumbnails_path . '/fi-cache/' . substr( basename( $fb_thumbnail_src[0], $file_ext ), 0, -1 ) . '-' . $md[0] . '.' . $file_ext ) ):
				 				echo '<meta property="og:image" content="' . 
				 					easy_facebook_share_plugin_url . 
				 					'fi-cache/' . 
				 					substr( basename( $fb_thumbnail_src[0], $file_ext ), 0, -1 ) . 
				 					'-' . $md[0] . '.' . 
				 					$file_ext . '" />' . "\n" . 
				 					'<link rel="image_src" href="' . 
				 					easy_facebook_share_plugin_url . 
				 					'fi-cache/' . 
				 					substr( basename( $fb_thumbnail_src[0], $file_ext ), 0, -1 ) . 
				 					'-' . $md[0] . '.' . 
				 					$file_ext . '"/>' . "\n";
				 			else:
				 				/*
				 				 @ The given thumbnail is already 200 x 200		 				
				 				 @ Overlay thumbnail based on selected
				 				 @ thumbnail mask
				 				*/
							 	
				 				easy_facebook_overlay( $fb_thumbnail_src[0], 
				 					substr( basename( $fb_thumbnail_src[0], $file_ext ), 0, -1 ), 
				 					exif_imagetype( $fb_thumbnail_src[0] ), 
				 					easy_facebook_share_thumbnails_path . "/masks/" . $md[0] . '.png', 
				 					easy_facebook_share_thumbnails_path . '/fi-cache/', 
				 					$md[0] );
				 					
				 				/*
				 				 @ Output our new thumbnail here
				 				*/
				 				echo '<meta property="og:image" content="' . 
				 					easy_facebook_share_plugin_url . 
				 					'fi-cache/' . 
				 					substr( basename( $fb_thumbnail_src[0], $file_ext ), 0, -1 ) . 
				 					'-' . $md[0] . '.' . 
				 					$file_ext . '" />' . "\n" . 
				 					'<link rel="image_src" href="' . 
				 					easy_facebook_share_plugin_url . 
				 					'fi-cache/' . 
				 					substr( basename( $fb_thumbnail_src[0], $file_ext ), 0, -1 ) . 
				 					'-' . $md[0] . '.' . 
				 					$file_ext . '"/>' . "\n";
				 			endif;
				 		
				 		else:
				 			/*
				 			 @ We deal with premium mask
				 			 @ in this area
				 			*/	
				 			
				 			$file_ext = ltrim( strstr( basename( $fb_thumbnail_src[0] ), '.' ), '.' );	 			
				 			$result=esft_get_premium_image( 
								array( 'method' => urlencode( 'display' ), 
								'host' => urlencode( $_SERVER['HTTP_HOST'] ),
								'thumbnail' => urlencode( substr( basename( $fb_thumbnail_src[0] ), 0, -4 ) ), 
								'image_type' => urlencode( $file_ext ), 
								'mask_type' => urlencode( $md[0] ) ) );							 		
							echo '<meta property="og:image" content="' . $result . '"/>' . "\n";
						 	echo '<link rel="image_src" href="' . $result . '"/>' . "\n";
				 		endif;	
			 		endif;		 			
			 	else:
			 		echo '<meta property="og:image" content="' . $fb_thumbnail_src[0] . '" />' . "\n";
			 		echo '<link rel="image_src" href="' . $fb_thumbnail_src[0] . '"/>' . "\n";
			 	endif;
			 else:
			 	$active = $wpdb->get_row("SELECT * FROM $table WHERE active = '1'", ARRAY_A);
			 	if( $active ):
			 		$image = $active['url'];
			 		
			 		//echo "\n";
				 	//echo "<!-- No Featured Image, use Default -->";
				 	//echo "\n";
				 	
		 			if( get_option( 'easy_share_mask_type' ) == "none" ):
				 		//$image = $active['url'];
				 		
				 		//echo "\n";
					 	//echo "<!-- No Featured Image, use Default -->";
					 	//echo "\n";
					 	echo '<meta property="og:image" content="' . $image . '"/>' . "\n";
					 	echo '<link rel="image_src" href="' . $image . '"/>' . "\n";
					 else:
					 	$name = $active['thumbnail'];					 	
					 	if( get_option( 'easy_share_mask_type' ) == "grunge" || get_option( 'easy_share_mask_type' ) == "masked" || get_option( 'easy_share_mask_type' ) == "punch" || get_option( 'easy_share_mask_type' ) == "rounded" ):
					 		echo '<meta property="og:image" content="' . easy_facebook_share_thumbnails_url . $name . "-" . get_option( 'easy_share_mask_type' ) . "." . $active['image_type'] . '" />' . "\n";
					 		echo '<link rel="image_src" href="' . easy_facebook_share_thumbnails_url . $name . "-" . get_option( 'easy_share_mask_type' ) . "." . $active['image_type'] . '"/>' . "\n";
					 	else:
					 		/*
						 	 @ Check premium Subscription
						 	*/
						 	$result = esft_check_premium( array( 'method' => urlencode( 'check_subscription' ), 'host' => urlencode( $_SERVER['HTTP_HOST'] ) ) );
							$data = unserialize( $result );
																	
							 if( $data ):
							 	/*
							 	 @ get thumbnail
							 	*/
							 	
							 	$result=esft_get_premium_image( 
							 			array( 'method' => urlencode( 'display' ), 
							 			'host' => urlencode( $_SERVER['HTTP_HOST'] ), 
							 			'mask_type' => urlencode( get_option( 'easy_share_mask_type' ) ), 
							 			'thumbnail' => urlencode( $name ), 
							 			'image_type' => urlencode( $active['image_type'] ) ) );
							 			
								echo '<meta property="og:image" content="' . $result . '"/>' . "\n";
					 			echo '<link rel="image_src" href="' . $result . '"/>' . "\n";	
					 			//close connection
								curl_close($ch);
							 endif;
					 	endif;
					 	
					 endif;
				 endif;
			 endif;
			 
			 echo "<!-- Easy Facebook Share Thumbnails -->";
			 echo "\n";
			 echo "\n";
		    }		    
		    else
		    {		 	
		 	//use default image instead
		 	//select active thumbnail in database
		 	$active = $wpdb->get_row("SELECT * FROM $table WHERE active = '1'", ARRAY_A);
		 	$image = $active['url'];
		 	$post_id = $post_id->ID;
		      	$site_title = get_the_title($post->ID);		      	
		      	$post_var = get_post($post_id, ARRAY_A);
		        $raw_content = $post_var['post_content'];
		        if( $post_var['post_content'] != "" ):
		        	$content = $post_var['post_excerpt'];
		        else:      
				$content = substr( strip_shortcodes( strip_tags($raw_content) ), 0, strpos( $raw_content, "." ) + 1 ); 		
			endif;			
		 	 
		 	 echo "\n";
		 	 echo "\n";
		 	 echo "<!-- Easy Facebook Share Thumbnails -->";
		 	 echo "<!-- This is non Post/Page -->";
			 echo "\n";
			 echo '<meta property="og:title" content="'. get_bloginfo('name') . '"/>' . "\n";
			 echo '<meta property="og:type" content="article"/>' . "\n";
			 echo '<meta property="og:url" content="' . get_bloginfo('wpurl') . '"/>' . "\n";
			 
			 if( get_option( 'esft_site_name' ) != "" ):
			 	echo '<meta property="og:site_name" content="' . get_option( 'esft_site_name' ) . '"/>' . "\n";
			 else:
			 	echo '<meta property="og:site_name" content="' . get_bloginfo('name') . '"/>' . "\n";
			 endif;
			 
			 //app id
			 if( get_option( 'esft_app_id' ) != "" ):
			 	echo '<meta property="fb:app_id" content="' . get_option( 'esft_app_id' ) . '"/>' . "\n";			 
			 endif;
			 			 	
			 echo '<meta property="og:description" content="' . get_bloginfo('description') . '"/>' . "\n";
			 	$active = $wpdb->get_row("SELECT * FROM $table WHERE active = '1'", ARRAY_A);
		 		if( $active ):
		 		
		 			//check mask if other than none
		 			//echo get_option( 'easy_share_mask_type' );
		 			if( get_option( 'easy_share_mask_type' ) == "none" ):
				 		$image = $active['url'];
				 		
				 		//echo "\n";
					 	//echo "<!-- No Featured Image, use Default -->";
					 	//echo "\n";
					 	echo '<meta property="og:image" content="' . $image . '"/>' . "\n";
					 	echo '<link rel="image_src" href="' . $image . '"/>' . "\n";
					 else:					 	
					 	$name = $active['thumbnail'];		
					 	if( get_option( 'easy_share_mask_type' ) == "grunge" || get_option( 'easy_share_mask_type' ) == "masked" || get_option( 'easy_share_mask_type' ) == "punch" || get_option( 'easy_share_mask_type' ) == "rounded" ):
					 		echo '<meta property="og:image" content="' . easy_facebook_share_thumbnails_url . $name . "-" . get_option( 'easy_share_mask_type' ) . "." . $active['image_type'] . '" />' . "\n";
					 		echo '<link rel="image_src" href="' . easy_facebook_share_thumbnails_url . $name . "-" . get_option( 'easy_share_mask_type' ) . "." . $active['image_type'] . '"/>' . "\n";
					 	else:
					 		//check for premium subscription					 	 	
						 	$results = esft_check_premium( 
						 	 	array( 'method' => urlencode( 'check_subscription' ), 
						 	 	'host' => urlencode( $_SERVER['HTTP_HOST'] ) ) 
						 	);
						 	 		
							$data = unserialize( $results );
							
							if( $data ):
							 	$result=esft_get_premium_image(
								 		array( 'method' => urlencode( 'display' ), 
								 		'host' => urlencode( $_SERVER['HTTP_HOST'] ), 
								 		'mask_type' => urlencode( get_option( 'easy_share_mask_type' ) ), 
								 		'thumbnail' => urlencode( $name ), 
								 		'image_type' => urlencode( $active['image_type'] ) )
								 	);
								echo '<meta property="og:image" content="' . $result . '"/>' . "\n";
						 		echo '<link rel="image_src" href="' . $result . '"/>' . "\n";
					 		
					 		endif;
					 	endif;
					 endif;
				 endif;
			// endif;
			 
			 echo "<!-- Easy Facebook Share Thumbnails -->";
			 echo "\n";
			 echo "\n";

		   }
}

//Wordpress admin menu
function fbthumbnails_menu()
{
	add_options_page('Easy Facebook Share Thumbnails', 'Easy Facebook Share Thumbnails', 'manage_options', 'facebook-thumbnail-slug', 'facebook_thumbnail_option');
}

function facebook_thumbnail_option()
{
	global $wpdb;	
	$table = $wpdb->prefix . "fbthumbnails";
	switch( $_GET['a'] )
		{
			case'delete-thumbnail':
				//delete thumbnail
				//perform deletion
				$wpdb->query("DELETE FROM $table WHERE id = '".$_GET['ID']."'"); 
				echo '<div id="message" class="updated fade"><p>Thumbnail deleted.</p></div>';				
			break;
			case'remove-thumbnail':
				//delete thumbnail
				//perform deletion
				$wpdb->query("UPDATE $table set active = '0' WHERE id = '".$_GET['ID']."'"); 
				echo '<div id="message" class="updated fade"><p>Thumbnail updated.</p></div>';				
			break;
			case'activate-thumbnail':
				//activate thumbnail
				//select current activate thumbnail		
				$active = $wpdb->get_row("SELECT * FROM $table WHERE active = '1'", ARRAY_A);		
				
				//and turn it off
				$wpdb->query( "UPDATE $table SET active = '0' WHERE id = '" . $active['id'] . "'" );
				
				//activate currently selected thumbnail from $_GET['id']
				$wpdb->query( "UPDATE $table SET active = '1' WHERE id = '" . $_GET['ID'] . "'" );
				echo '<div id="message" class="updated fade"><p>Thumbnail Activated.</p></div>';
			break;
			case'change-mask':
				update_option( 'easy_share_mask_type', $_POST['mask_type'] );
				
				//check if premium
				//and curl back to API
				if( $_POST['mask_type'] != "none" && $_POST['mask_type'] != "grunge" && $_POST['mask_type'] != "masked" && $_POST['mask_type'] != "punch" && $_POST['mask_type'] != "rounded" ):
					$overlay= esft_overlay( 
					 	array( 'method' => urlencode( 'overlay' ), 
					 	'host' => urlencode( $_SERVER['HTTP_HOST'] ), 
					 	'image_url' => urlencode( $_POST['thumbnail_url'] ), 
					 	'thumbnail' => $_POST['thumbnail'], 
					 	'image_type' => $_POST['image_type'], 
					 	'mask_type' => $_POST['mask_type'] ) );					
				endif;
				
			break;
			case'other-settings':
				//other settings
				update_option( 'esft_site_name', $_POST['site_name'] );
				update_option( 'esft_app_id', $_POST['app_id'] );
				update_option( 'esft_published_time', $_POST['published_time'] );
				update_option( 'esft_modified_time', $_POST['modified_time'] );
			break;
			case'add-new-thumbnail':
				
				list($width, $height, $type, $attr) = getimagesize( $_FILES['image']['tmp_name'] );
						
		
					//image directories
					$upload_dir = wp_upload_dir();
					//add new thumbnail			
					//image name generator
					//use md5 and rand() to generate new image name
					$image_name = md5(rand());
					
					//determine active value
					if($_POST['active'] == ""){
					
					 //not use as default
					 // leave setting as it is
					 $active = "0";
					
					 //determine image type
					 if(exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_GIF )
					 {
					  	$target_path = easy_facebook_share_thumbnails_path . "/thumbnails/" . $image_name . ".gif"; 
					  	$url = easy_facebook_share_thumbnails_url . $image_name . ".gif";
					 // endif;
					 }
					 if(exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_JPEG )
					 {
					  	$target_path = easy_facebook_share_thumbnails_path . "/thumbnails/" . $image_name . ".jpg"; 
					  	$url = easy_facebook_share_thumbnails_url . $image_name . ".jpg";
					 // endif;
					 }
					 if(exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_PNG )
					 {
					  	$target_path = easy_facebook_share_thumbnails_path . "/thumbnails/" . $image_name . ".png"; 
					  	$url = easy_facebook_share_thumbnails_url . $image_name . ".png";
					 // endif;
					 }		  
					  
					  //check file upload if image 
					  if((exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_GIF ) || (exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_JPEG ) || (exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_PNG ))
					  {
					  	 if( exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_GIF )
					  			$image_type = "gif";
					  	 
					  	 if( exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_JPEG )
					  			$image_type = "jpg";
					  			
					  	 if( exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_PNG )
					  			$image_type = "png";
					  			
					  			
					  	 //validate image
					  	 //perform operation
						 if(move_uploaded_file($_FILES['image']['tmp_name'], $target_path)) {	
						 
						 //echo easy_facebook_share_thumbnails_path . '/resize_class.php';
						 include easy_facebook_share_thumbnails_path . '/resize_class.php';
						
						 //resize to 200 x 200 pixels
						 //Image resize
						 $resize = new resize( $target_path );							 						 
						 $resize -> resizeImage( 200, 200, 'crop' );						 						 
						 $resize -> saveImage( $target_path , 100);
						 
						 $dir_list = scandir( easy_facebook_share_thumbnails_path . "/masks/" );
					
						 for( $i=2; $i<count( $dir_list ); $i++ ){
							$fileinfo = pathinfo( $dir_list[$i] );
							easy_facebook_overlay( $target_path, $image_name, exif_imagetype( $target_path ), easy_facebook_share_thumbnails_path . "/masks/" . $dir_list[$i], easy_facebook_share_thumbnails_path . '/thumbnails/', $fileinfo['filename'] );
						 }						 
						
						 //insert to database
						 $wpdb->insert( $table, array(
										'thumbnail' => $image_name,
										'path' => $target_path,
										'url' => $url,
										'active' => $active,
										'image_type' => $image_type )
										);
						 //declare success message
						 echo '<div id="message" class="updated fade"><p>Success!.</p></div>';
						 
						 }else{
						 
						 //declare error message
						 echo '<div id="message" class="updated fade"><p>There was an error uploading the file, please try again! Please be sure that the thumbnails folder is writable.</p></div>';
						 
						 }
					  }
					  else
					  {
					  	 
					  	//unrecognised, declare error and stop operation
					   	echo '<div id="message" class="updated fade"><p>File type is not supported. Make sure it is either .PNG, .GIF, .JPEG only.</p></div>';
					  }
					//}
					 
					}else{
					
					//use as default
					//first, deactivate currently used thumbnail
					// then set the new thumbnail as default
					
					//select current activate thumbnail		
					$fbthm = $wpdb->get_row("SELECT * FROM $table WHERE active = '1'", ARRAY_A);
					
					//and turn it off
					$wpdb->query( "UPDATE $table SET active = '0' WHERE id = '" . $fbthm['id'] . "'" );
					
					$active = "1";
					 					 
					//determine image type
					 if(exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_GIF )
					 {
					  $target_path = easy_facebook_share_thumbnails_path . "/thumbnails/" . $image_name . ".gif"; 
					  	$url = easy_facebook_share_thumbnails_url . $image_name . ".gif";
					 // endif;
					 }
					 if(exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_JPEG )
					 {
					    	$target_path = easy_facebook_share_thumbnails_path . "/thumbnails/" . $image_name . ".jpg"; 
					  	$url = easy_facebook_share_thumbnails_url . $image_name . ".jpg";
					 // endif;
					 }
					 if(exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_PNG )
					 {
					   	$target_path = easy_facebook_share_thumbnails_path . "/thumbnails/" . $image_name . ".png"; 
					  	$url = easy_facebook_share_thumbnails_url . $image_name . ".png";
					 // endif;
					 }	 
					
					 //check file upload if image 
					  if((exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_GIF ) || (exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_JPEG ) || (exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_PNG ))
					  {
					  	 if( exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_GIF )
					  			$image_type = "gif";
					  	 
					  	 if( exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_JPEG )
					  			$image_type = "jpg";
					  			
					  	 if( exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_PNG )
					  			$image_type = "png";
					  			
					  	//validate image
					  	 //perform operation
						 if(move_uploaded_file($_FILES['image']['tmp_name'], $target_path)) {	
						 
						 //echo easy_facebook_share_thumbnails_path . '/resize_class.php';
						 include easy_facebook_share_thumbnails_path . '/resize_class.php';
						 //echo $target_path;
						 //resize to 200 x 200 pixels
						 //Image resize
						 $resize = new resize( $target_path );						 						 
						 $resize -> resizeImage( 200, 200, 'crop' );						 						 
						 $resize -> saveImage( $target_path , 100);
						 
						 $dir_list = scandir( easy_facebook_share_thumbnails_path . "/masks/" );
					
						 for( $i=2; $i<count( $dir_list ); $i++ ){
							$fileinfo = pathinfo( $dir_list[$i] );
							easy_facebook_overlay( $target_path, $image_name, exif_imagetype( $target_path ), easy_facebook_share_thumbnails_path . "/masks/" . $dir_list[$i], easy_facebook_share_thumbnails_path . '/thumbnails/', $fileinfo['filename'] );
						 }
						
						 //insert database
						 $wpdb->insert( $table, array(
										'thumbnail' => $image_name,
										'path' => $target_path,
										'url' => $url,
										'active' => $active,
										'image_type' => $image_type )
										);
						 //declare success message
						 echo '<div id="message" class="updated fade"><p>Success!.</p></div>';
						 
						 }else{
						 
						 //declare error message
						 echo '<div id="message" class="updated fade"><p>There was an error uploading the file, please try again! Please be sure that the thumbnails folder is writable.</p></div>';
						 
						 }
					  }
					  else
					  {
					  	 
					  	//unrecognised, declare error and stop operation
					   	echo '<div id="message" class="updated fade"><p>File type is not supported. Make sure it is either .PNG, .GIF, .JPEG only.</p></div>';
					  }
					//}
					
					}
				//endif;
			update_option( 'easy_share_mask_type', "rounded" );
			break;
		}
	switch($_GET['page']) {		
		case 'facebook-thumbnail-slug':		
?>
<?php
	
	$record = $wpdb->get_var($wpdb->prepare("SELECT COUNT(*) FROM %s", $table ));
		if ( $record != "0" )
			{
?>
		<div class="wrap">
		 <?php
		 	echo '<a href="http://easyfacebooksharethumbnail.com" target="_blank"><img src="' . plugins_url('easy-facebook-share-thumbnails/images/logosm.jpg') . '"></a>';
		 ?>
		 <h2>Welcome to Easy Facebook Share Thumbnail</h2>
		 <?php
		 function get_external_ip() {
		    $ch = curl_init("http://icanhazip.com/");
		    curl_setopt($ch, CURLOPT_HEADER, FALSE);
		    curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
		    $result = curl_exec($ch);
		    curl_close($ch);
		    if ($result === FALSE) {
		        return "ERROR";
		    } else {
		        return trim($result);
		    }
		}	
		
		//echo get_external_ip();
		//print_r( $_SERVER );
		//$ip=$REMOTE_ADDR;  
		//echo "IP: $ip";
		
		/*
		 @ Check if blog has tagline
		 @ useful when sharing homepage in
		 @ facebook
		*/
		if( get_bloginfo(  'description' ) == "" )
			echo '<div id="message" class="error"><p>Please define a tagline in Settings > General > Tagline. This is used for the facebook open graph site description when the post excerpt is undefined.</p></div>';
		
		/*
		 @ If there's a default thumbnail
		 @ Force user to upload/set default thumbnail
		*/
		if( !$wpdb->get_var( "SELECT COUNT(*) FROM $table WHERE active=1" ) )
			echo '<div id="message" class="error"><p>No default thumbnail! Please upload or set new default thumbnail.</p></div>';
		
    		?>     
		 <div class="postbox">
		  <table class="form-table">
		   <tr valign="top" class="alternate">
		    <th scope="row"><label>Available Thumbnail</label></th><th scope="row"><label>Default Mask</label></th><th scope="row"><label>Default Thumbnail</label></th><th scope="row"><label>Action</label></th>
		   </tr>
<?php

			foreach( $wpdb->get_results("SELECT * FROM $table ORDER BY active desc") as $key => $row ) {
			// each column in your row will be accessible like this
			$thumbnail = $row->thumbnail;
			$url = $row->url;
			$activate = $row->active;
?>
		    <tr>
		     <td>
		      <img src = "<?php echo easy_facebook_share_thumbnails_url . $thumbnail . '-rounded.' . $row->image_type; ?>" width = "50px">
		     </td>
		     <td>		     
		      <form method="post" action="options-general.php?page=facebook-thumbnail-slug&a=change-mask">
		       <input type="hidden" name="thumbnail_url" value="<?php echo $row->url; ?>">
		       <input type="hidden" name="thumbnail" value="<?php echo $row->thumbnail; ?>">
		       <input type="hidden" name="image_type" value="<?php echo $row->image_type; ?>">
		      
		       <select name="mask_type" <?php if($activate == "1"){ echo ""; }else{ echo "hidden"; } ?>> 
		        <option value="none" <?php selected( get_option( 'easy_share_mask_type' ), "none" ); ?>>None</option>
		        <option value="grunge" <?php selected( get_option( 'easy_share_mask_type' ), "grunge" ); ?>>Grunge</option>
		        <option value="masked" <?php selected( get_option( 'easy_share_mask_type'), "masked" ); ?>>Masked</option>
		        <option value="punch" <?php selected( get_option( 'easy_share_mask_type'), "punch" ); ?>>Punch</option>
		        <option value="rounded" <?php selected( get_option( 'easy_share_mask_type'), "rounded" ); ?>>Rounded</option>
		        <?php		        	/**
		        /*
	        	 @ Check for any premium subscription here
	        	 @ Return dropdown
	        	*/	        
	        	
			$result = esft_get_subscription( 
				array( 'method' => urlencode( 'get' ), 
				'host' => urlencode( $_SERVER['HTTP_HOST'] ), 
				'image_url' => urlencode( $row->url ), 
				'thumbnail' => $row->thumbnail, 
				'image_type' => $row->image_type ) 
				);			        		
		        	 	
					$data = unserialize( $result );
					print_r( $data );										
					 if( $data ):
					for( $x=0; $x < count( $data ); $x++ ){					
						echo '<option value="' . $data[$x]['content'] . '"';
						selected( get_option( 'easy_share_mask_type'), $data[$x]['content'] ); 
						echo '>' . ucfirst( $data[$x]['content'] ) . '</option>';					
					}				
					
					endif;
										
		        ?>
		       </select>
		       <input type="submit" class="button-primary" value = "Change mask" <?php if($activate == "1"){ echo ""; }else{ echo 'disabled="disabled"'; } ?>>
		      </form>
		     </td>
		     <td>
		      <?php if($activate == "1"){ echo "Yes"; } else { echo "No"; }; ?>
		     </td>
		     <td>
		      <input type="submit" class="button-primary" value = "Delete" onClick = "location.href='options-general.php?page=facebook-thumbnail-slug&a=delete-thumbnail&ID=<?php echo $row->id; ?>';"> 
		      <?php if($activate == "1") {?>
		       <input type="submit" class="button-primary" value = "Unset as default" onClick = "location.href='options-general.php?page=facebook-thumbnail-slug&a=remove-thumbnail&ID=<?php echo $row->id; ?>';">
		      <?php }else{ ?> 
		       <input type="submit" class="button-primary" value = "Set as default" onClick = "location.href='options-general.php?page=facebook-thumbnail-slug&a=activate-thumbnail&ID=<?php echo $row->id; ?>';">
		      <?php } ;?>
		     </td>
		    </tr>
<?php
				}				
?>		   			 	
 		  </table>
 		 </div>
		</div>
		
		<?php
		/*
		 @ Check premium susbcription
		 @ if not, display message to persuade user
		 @ to buy premium
		*/
		$chck_premium = esft_check_premium( array( 'method' => urlencode( 'check_subscription' ), 'host' => urlencode( $_SERVER['HTTP_HOST'] ) ) );
		
		if( $chck_premium ):
		?>
			<div class="wrap">
			<div style="border: 1px solid; margin: 10px 0px; padding: 8px 10px 8px 40px; background-repeat: no-repeat; background-position: 10px 10px; border-radius: 3px 3px 3px 3px;color: #000000; background-color: #E1FED4;"><p>You are using the premium version with extra masks enabled. To unlock more, <a href="http://easyfacebooksharethumbnail.com/unlock/" target="_blank">Click Here</a>!</p></div>
			</div>
		<?php
				
		endif;
		
		if( !$chck_premium ):
		?>
			<div class="wrap">
			<div style="border: 1px solid; margin: 10px 0px; padding: 8px 10px 8px 40px; background-repeat: no-repeat; background-position: 10px 10px; border-radius: 3px 3px 3px 3px;color: #9F6000; background-color: #FEEFB3;"><p>You are using the free version with 4 great overlay masks. We have others available that you can unlock! <a href="http://easyfacebooksharethumbnail.com/unlock/" target="_blank">Click Here</a></p></div>
			</div>
		<?php
		endif;
		?>
		
		<div class="wrap">
		<h2>Thumbnail Mask Samples</h2>
		 <div class="postbox">
 		  <table class="form-table" cellpadding="20">
 		  <tr><td><img src="<?php echo plugins_url( '/easy-facebook-share-thumbnails/masks-sample/roundmask.png' ); ?>"></td><td><img src="<?php echo plugins_url( '/easy-facebook-share-thumbnails/masks-sample/grungesample.png' ); ?>"></td>
 		  </tr>
 		  <tr><td><img src="<?php echo plugins_url( '/easy-facebook-share-thumbnails/masks-sample/roundedsample.png' ); ?>"></td><td><img src="<?php echo plugins_url( '/easy-facebook-share-thumbnails/masks-sample/punchsample.png' ); ?>"></td></tr>
 		  </table>
 		  </div>
 		 </div>
 		 
 		<?php
 		 /*
 		  @ Check and display premium
 		  @ overlay here
 		*/
 		$premium_sample = esft_display_premium_samples( array( 'method' => 'display_sample', 'host' => urlencode( $_SERVER['HTTP_HOST'] ) ) );
 		
 		if( $premium_sample ):	
 		?>
 		<div class="wrap">
		<h2>Premium Thumbnail Mask Samples</h2>
		 <div class="postbox">
 		  <table class="form-table" cellpadding="20">
 		<?php
 		//print_r($premium_sample );
 		for( $x=0; $x<count( $premium_sample ); $x++ ):
 		if( !fmod( $x, 2 ) )
 			echo '<tr><td><img src="' . $premium_sample[$x]['url'] . '"></td><td><img src="' . $premium_sample[$x + 1]['url'] . '"></td>' ;//</tr>
 		
 		
 		if( fmod( $x, 2 ) )
 			echo '</tr>';
 		
 		endfor;
 		?>
 		  </table>
 		  </div>
 		 </div> 		 
<?php
		 endif;
			}
?>
		<div class="wrap">
		<form method="post" enctype="multipart/form-data" action="options-general.php?page=facebook-thumbnail-slug&a=add-new-thumbnail">
		<input type="hidden" name="" id="info_update1" value="true" />
		 <h2>Upload New Thumbnail</h2>
		 <div class="postbox">
		  <table class="form-table">
		   <!--<tr valign="top" class="alternate"><th scope="row"style="width:32%;" ><label>Thumbnail Name:</label></th><td><input type = "text" name = "thumbnail"></td></tr>-->
		   <tr valign="top" class="alternate"><th scope="row"style="width:32%;" ><label>Set To Default. Use the thumbnail about to be uploaded for posts without featured images and as well as the home page.:</label></th><td><input type = "checkbox" name = "active"></td></tr>	  
		   <tr valign="top" class="alternate"><th scope="row"style="width:32%;" ><label>Image:</label></th><td><input type = "file" name = "image"></td></tr> 
		   <tr valign="top" class="alternate"><th scope="row"style="width:32%;" ></th><td><input type="submit" class="button-primary" value = "Submit"></td></tr> 
		  </table>
		 </div>
		</form>
		</div>
		
		<div class="wrap">
		<form method="post" action="options-general.php?page=facebook-thumbnail-slug&a=other-settings">
		 <h2>Additional Facebook OpenGraph Settings</h2>
		 <div class="postbox">		  
		  <table class="form-table">
		  
		   <tr valign="top" class="alternate"><th scope="row"style="width:32%;" ><label>Specify Site Name:</label></th><td><input type = "text" name = "site_name" value="<?php echo get_option( 'esft_site_name' ); ?>"></td></tr>
		   <tr valign="top" class="alternate"><th scope="row"style="width:32%;" ><label>Specify App ID:</label></th><td><input type = "text" name = "app_id" value="<?php echo get_option( 'esft_app_id' ); ?>"></td></tr>
		   
		   <tr valign="top" class="alternate"><th scope="row"style="width:32%;" ><label>Use Published Time Info:</label></th><td><input type = "checkbox" name = "published_time" <?php get_option( 'esft_published_time' ) == "on" ? $chk = "checked" : $chk = ""; echo $chk; ?>></td></tr>	
		   <tr valign="top" class="alternate"><th scope="row"style="width:32%;" ><label>Use Modified Time Info:</label></th><td><input type = "checkbox" name = "modified_time" <?php get_option( 'esft_modified_time' ) == "on" ? $chk = "checked" : $chk = ""; echo $chk; ?>></td></tr>	
		   <tr valign="top" class="alternate"><th scope="row"style="width:32%;" ></th><td><input type="submit" class="button-primary" value = "Submit"></td></tr> 
		   <tr valign="top" class="alternate">
		    <td colspan="2">
		     <label><input value="Debug or validate your pages" type="button" onclick="window.open( 'https://developers.facebook.com/tools/debug' );" ></label> 
		     <label><input value="Generate like button code" type="button" onclick="window.open( 'http://developers.facebook.com/docs/reference/plugins/like/' );" ></label>
		    </td>
		   </tr>
		   <tr valign="top" class="alternate">
		    <td colspan="2">
		     <label>
		     <strong>FAQ:<br><br>Q: I have updated the featured image but it is not being reflected when sharing the post on facebook</strong>
		     <br>A: When trying out sharing functionality on facebook, your page may be saved or cached in the incorrect manner. If you have been making a number of changes to your post and would like facebook to get a fresh copy, kindly add a random number to your post url instead of the Xs like so:
http://domain.com/this-is-the-post-title/?efs=XXXX
This will trick facebook into thinking that you are sharing a different page, and load up the latest copy (of the same page).<br><br>
			<strong>Q: I have updated the plugin and it stopped working!</strong><br>A: Kindly try and deactivate and reactive the plugin on the Plugins page. If this doesnt work, please make sure that no other facebook function-adding plugins are running alongside this one. <br/><br/> 
			<strong>Q: I cannot seem to upload an image. </strong><br/>A: Be sure that the thumbnails directory in the plugin directory is writable.<br/><br/>
			<strong>Q: I want to use different thumbnail for each pages/posts that I want to share in Facebook
			</strong><br/>A: You can do this using Featured Image in Post/Page settings.<br/><br/>
			<strong>Q: My current theme does not support Featured Image
			</strong><br/>A: The plugin will automatically activate Featured Image even the current theme used does not support this feature.<br/><br/>
			<strong>Q: What image files that are currently supported? 
			</strong><br/>A: Only .GIF, .PNG and .JPEG that are currently supported.<br/><br/>
			<strong>Q: Something is not working correctly. Whats wrong?
			</strong><br/>A: The plugin is still in its infancy. The rapid evolution of facebook is great, but its hard to keep up sometimes when developing free plugins. Were committed to the plugin though! Please help by reporting any bugs you find. Please do this before giving us a bad rating - we will do everything we can to fix things! <a href="http://easyfacebooksharethumbnail.com/report-bug/" target="_blank">Report A bug</a>
			</label><br/><br/>
		     <iframe src="http://easyfacebooksharethumbnail.com/info.html" width="700px" height="400px" frameborder="0" scrolling="no"></iframe>
		    </td>
		   </tr>
		  </table>
		 </div>
		</form>
		</div>
		
<?php
		break;
	}
}

/* Define the custom box */
add_action( 'add_meta_boxes', 'esft_add_custom_box' );

// backwards compatible (before WP 3.0)
// add_action( 'admin_init', 'myplugin_add_custom_box', 1 );

/* Do something with the data entered */
add_action( 'save_post', 'esft_save_postdata' );

/* Adds a box to the main column on the Post and Page edit screens */
function esft_add_custom_box() {
    $screens = array( 'post', 'page' );
    foreach ($screens as $screen) {
        add_meta_box(
            'esft',
            __( 'Easy Share Facebook Thumbnail', 'esft' ),
            'esft_inner_custom_box',
            $screen,
            'side'
        );
    }
}

function esft_save_postdata(){
  // verify if this is an auto save routine. 
  // If it is our form has not been submitted, so we dont want to do anything
  if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
      return;

  // verify this came from the our screen and with proper authorization,
  // because save_post can be triggered at other times

  if ( !isset( $_POST['esft_noncename'] ) || !wp_verify_nonce( $_POST['esft_noncename'], plugin_basename( __FILE__ ) ) )
      return;

  
  // Check permissions
  if ( 'page' == $_POST['post_type'] ) 
  {
    if ( !current_user_can( 'edit_page', $post_id ) )
        return;
  }
  else
  {
    if ( !current_user_can( 'edit_post', $post_id ) )
        return;
  }

  // OK, we're authenticated: we need to find and save the data

  //if saving in a custom table, get post_ID
  $post_ID = $_POST['post_ID'];
  //sanitize user input
  $mydata = sanitize_text_field( $_POST['mask_type'] );

  // Do something with $mydata 
  // either using 
  add_post_meta($post_ID, '_esft_meta', $mydata, true) or
  update_post_meta($post_ID, '_esft_meta', $mydata);
  
  $fb_thumbnail_src = wp_get_attachment_image_src(get_post_thumbnail_id($thumbnail->ID), array( 200, 200 ) );
  $tn=get_the_post_thumbnail( $post_ID );
  if( $_POST['mask_type'] != "none" && $_POST['mask_type'] != "grunge" && $_POST['mask_type'] != "masked" && $_POST['mask_type'] != "punch" && $_POST['mask_type'] != "rounded" ):
	$overlay= esft_overlay( 
	 	array( 'method' => urlencode( 'overlay' ), 
	 	'host' => urlencode( $_SERVER['HTTP_HOST'] ), 
	 	'image_url' => urlencode( $fb_thumbnail_src[0] ), 
	 	'thumbnail' => basename( substr( basename( $fb_thumbnail_src[0] ), 0, -4 ) ), 
	 	'image_type' => ltrim( strstr( basename( $fb_thumbnail_src[0] ), '.' ), '.' ), 
	 	'mask_type' => $_POST['mask_type'] ) );					
 endif;

}

function esft_inner_custom_box( $post ){
	wp_nonce_field( plugin_basename( __FILE__ ), 'esft_noncename' );
	//print_r( get_post_meta($post->ID, '_esft_meta') );
	
	//check if featured image available
	//then get the url
	if( has_post_thumbnail( $post->ID ) )
		$get_fi = wp_get_attachment_image_src( get_post_thumbnail_id($post->ID), 'full' );
	
	if( $get_fi[1] < 200 || $get_fi[2] < 200 ):
		//add_action( 'admin_notices', esft_message_admin( 'Error! Featured image dimension must greater than 200 x 200. ', true ) );
		$disable_dd = true;
	endif;
?>
	<p>
		<label for="smashing-post-class"><?php _e( "Default Mask for Featured Image:", 'esft' ); ?></label>
		<br />
		<select name="mask_type" <?php if( $disable_dd == true ): echo "disabled=disabled"; endif; ?> > 
	        <option value="none" <?php selected( get_post_meta($post->ID, '_esft_meta', true), "none" ); ?>>None</option>
		<option value="grunge" <?php selected( get_post_meta($post->ID, '_esft_meta', true), "grunge" ); ?>>Grunge</option>
		<option value="masked" <?php selected( get_post_meta($post->ID, '_esft_meta', true), "masked" ); ?>>Masked</option>
		<option value="punch" <?php selected( get_post_meta($post->ID, '_esft_meta', true), "punch" ); ?>>Punch</option>
		<option value="rounded" <?php selected( get_post_meta($post->ID, '_esft_meta', true), "rounded" ); ?>>Rounded</option>
	        <?php	
	        	/*
	        	 @ Check for any premium subscription here
	        	 @ Return dropdown
	        	*/	        	
			$result = esft_get_subscription( 
				array( 'method' => urlencode( 'get' ), 
				'host' => urlencode( $_SERVER['HTTP_HOST'] ), 
				'image_url' => urlencode( $get_fi[0] ), 
				'thumbnail' => $row->thumbnail, 
				'image_type' => $row->image_type ) 
				);
				
			$data = unserialize( $result );
															
			if( $data ):
			
			for( $x=0; $x < count( $data ); $x++ ){					
					echo '<option value="' . $data[$x]['content'] . '"';
					selected( get_post_meta($post->ID, '_esft_meta', true), $data[$x]['content'] ); 
					echo '>' . ucfirst( $data[$x]['content'] ) . '</option>';					
			}				
					
			endif;
										
		        ?>
		</select>
		
		<p style="font-size: 11px;"><i><a href="http://easyfacebooksharethumbnail.com/masks/" target="_blank">See Mask Samples</a></i></p>
		<?php
			if( $disable_dd == true )
				echo 'Featured image dimension must greater than 200 x 200.';
		?>
	</p>
	
<?php
}



?>